        subroutine fortran_cvequid(IRET)
C
C                C V E Q U I D
C
C  A MODIFIED VERSION OF STOICHIO TO TAKE INTO ACCOUNT ALL TYPES OF
C  EXPERIMENTAL ERRORS.
C
C  * * * * * * * * VERSION OF OCTOBER, 1984 * * * * * * * * * * * * * *
C               EXTENDED ON SEPTEMBER 11, 1986
C
C   Implemented on PC AT on May 1988
C
C   Last revision Feb 13, 1994
C
C   Interfaced to C as a subroutine, Dec 13, 2006
C
C      UP TO:
C             15 EQUILIBRIA
C             20 SPECIES
C              5 MASS-BALANCE CONSTRAINTS
C             20 BASIC SOLUTIONS (SOLIDS)
C             30 INTERMEDIATE SOLUTIONS
C             40 PATHS BETWEEN SOLUTIONS
C              5 POTENTIOMETRIC TITRATIONS
C             50 PARAMETERS TO BE DETERMINED (EXCLUDING TITRANT VOL'S)
C
C                  MAIN
C
      IMPLICIT REAL*8(A-H,O-Z)
      LOGICAL CORVM(5),CORALF(5),COREST(5),SING
      INTEGER EACHIT
      INTEGER NVA(4),NVARAB(4,15),NVAS(4),NVAR(20),NVARS(20),
     *      NVM(5),NALF(5),NEST(5),WADJ(40),NWC(30)
      REAL*8 BE(4,15),H(50,50),LK(15),P(15,5),W(50),X(50),X1(50),
     *      ENRNST(20),DX(50),DX1(50),DK(15),DK1(15),DEV(200),DECHAR(
     *      50,5),A(15,20),C(250,20),EMFX(200,50),EMF(200),DEMF(200),
     *      EMFV(200),WPOM(15),PHSCMP(5,15),COVK(15,15),QCOMP(20,20),
     *      V1(200),DEV1(200),CHAR1(50,5),DECHR1(50,5) ,
     *      WW(50),VCOMP(40),VM(5),EST(5),ALFA(5),STDK(15,15)
     *      ,STDAP(50),DEMF1(200),CHAR(50,5),V(200)
      COMMON
     *      /UNI/ M,N,MM,NWAVE,NWAVAR,NREDE,NSTODE,NCHAR,NCHARV,NSPEK,
     *      NPOT,NIM,NNREDE,MNREDE,NREDE1,M1,MX,MX1,ISOL,NPARAM,MXNWA1
     *      ,MXNWA,NEXP,NUMIT,MAXMAR,MAXIT,MAXU,KON30,KON15,KON5,
     *      EACHIT,MMM,MMX,MXX,MXX1,MXC,MXW,MXV,MXVV,MXA,NPC,NVRTEX,
     *      NVRTXC,NADJ,NADJC,NCOMP,NCOMP1
     *      /U1/
     *      BLOG,RMIND,REL,DUMDT,RLAMBD,VMARQ,WNORM,RKRYT,EST,ALFA,
     *      SIGEMF,SIGMAV,COEXP,PARS,UZG
     *      ,FACTST
      COMMON
     *      /C1/ NVA,NVARAB,WPOM,EMFV,EMFX
     *      /C2/ BE,DEMF,DEV
     *      /C3/ C,DECHAR
     *      /C4/ NVAS,W
     *      /C5/ CHAR
     *      /C6/ VM
     *      /C8/ T(250,5)
     *      /C9/ V
     *      /C11/ H
     *      /C12/ P
     *      /C13/ ENRNST
     *      /C16/ EMF,A,PHSCMP
     *      /C17/ LK
     *      /C20/ NRUN
     *      /C21/ INDEKS
      COMMON
     *      /C22/ NWC,WADJ,NVAR,NVARS,NVM,NALF,NEST
     *      /C24/ QCOMP,WW,VCOMP
     *      /C25/ DK,DK1,DX,DX1
     *      /C26/ STDAP,COVK,STDK
     *      /C27/ CORVM,COREST,CORALF
     *      /C30/ V1,DEV1,CHAR1,DECHR1,DEMF1
        COMMON /ADDED/ IDERIV,NVART,VART(5)
      NRUN=1
C      
C Open files
C
C        OPEN (8,FILE='FOR008',STATUS='OLD')
        OPEN (9,FILE='FOR009',STATUS='UNKNOWN') 
c        OPEN (10,FILE='FOR010',STATUS='UNKNOWN')
c        OPEN (11,FILE='FOR011',STATUS='UNKNOWN')
      WRITE (9,2000)
2000  FORMAT(20X,'Program CVEQUID - extended PC version - March 1994'//)
C
C   Initialize variables for a particular run and clear tables if requested.
C
100   NUMIT=0
      IRET=0
      SING=.TRUE.
      NWAVAR=0
      NCHARV=0
      NWAVE=0
      INDEKS=0
      KON5=5
      KON15=15
      KON30=50
      BLOG=DLOG(1.0D1)
c      DO 13 I=1,20
c13      NVAR(I)=0
c      DO 101 I=1,20
c101      ENRNST(I)=0.0
        DO 104 I=1,10
        DK(I)=0.D0
      DO 104 J=1,15
          STDK(I,J)=0.0
104      CONTINUE
      DO 201 I=1,50
        DX(I)=0.0
201        DX1(I)=0.0
      DO 105 I=1,50
      DO 105 J=1,5
105        DECHAR(I,J)=0.0
        CALL READIN(*40)
      CALL PROC(*40)
      NRDSTD=NREDE*NSTODE+MM
      DO 1 I=1,MM
1        X(I)=LK(I)
      IF(NREDE.EQ.0)GOTO 2
      DO 3 I=1,NREDE
        I1=(I-1)*NSTODE+MM
      DO 4 J=1,NSTODE
4          X(I1+J)=P(I,J)
3        CONTINUE
2      CONTINUE
      DO 31 I=1,NCOMP
        NVARI=NVAR(I)
        IF(NVARI.EQ.0) GOTO 31
        NVARSI=NVARS(I)
        DO 32 K=1,NVARI
32          X(NVARSI+K)=QCOMP(I,K)
31      CONTINUE
      IF(NVRTXC.EQ.0) GOTO 33
        DO 34 I=1,NVRTXC
34        X(MXC+I)=WW(NWC(I))
33      CONTINUE
      IF(NADJC.EQ.0) GOTO 35
      DO 36 I=1,NADJC
36        X(MXW+I)=VCOMP(WADJ(I))
35      CONTINUE
      DO 37 I=1,NEXP
        IF(CORVM(I)) GOTO 38
        X(NVM(I))=VM(I)
38      CONTINUE
      IF(CORALF(I)) GOTO 39
        X(NALF(I))=ALFA(I)
39      CONTINUE
        IF(COREST(I))GOTO 37
        X(NEST(I))=EST(I)
37      CONTINUE
       IF(NVRTEX.EQ.NCOMP) GOTO 59
      DO 50 I=NCOMP1,NVRTEX
50        WW(I)=1.0/WW(I)
59      CONTINUE
      IF (NWAVAR.EQ.0) GOTO 5
      DO 6 I=1,NWAVAR
        NVAI=NVA(I)
      MXNVSI=MXX+NVAS(I)
      DO 7 J=1,NVAI
7      X(MXNVSI+J)=DLOG(BE(I,NVARAB(I,J)))
6       CONTINUE
5      CONTINUE
      CALL BLANCE
C Punch measured values
c        if (nvart.eq.0) then
c          write (10,'(2f10.3)') (v(i),emf(i),i=1,npot)
c        else        
c          do ipot=1,npot
c            vv=0.0
c          do i=1,nim
c            if (vart(i).ne.0.0) vv=vv+vart(i)*dlog(t(ipot,i))/blog
c            enddo
c          write (10,'(2f10.3)') vv,emf(ipot)
c          enddo
c        endif
      CALL UMDES(*40)
      CALL MINSUM(UZG)
      IF (EACHIT.EQ.0) WRITE (9,1111)
1111      FORMAT (//30X,'P A R A M E T E R S')
      IF (EACHIT.EQ.0) WRITE (9,1112) NUMIT
1112      FORMAT (/1X,'Number of iteration:',I4)
      IF (EACHIT.EQ.0) CALL PIS(1,1,1,1,NPARAM,6,X)
      IF (EACHIT.GT.0) CALL WRITIN
      IF (EACHIT.GT.1) CALL RESWR
      IF (EACHIT.GT.2) CALL CONCWR
C
C Start main iteration.
C
      DO 8 NUMIT=1,MAXIT
      CALL DERIV(*22)
      IF(NPOT.EQ.0) GOTO 63
      DO 60 I=1,NPOT
        DEV1(I)=DEV(I)
      DEMF1(I)=DEMF(I)
60        V1(I)=V(I)
63      CONTINUE
      IF (NCHARV.EQ.0) GOTO 62
      DO 61 I=1,NSPEK
      DO 61 J=1,NCHARV
61      CHAR1(I,J)=CHAR(I,J)
62      CONTINUE
C
C Start Marquardt iteration.
C
        DO 9 NUMMAR=1,MAXMAR
      CALL HEVL(*22)
      CALL OPTCH(H,W,KON30,NPARAM,1,*24)
      GOTO 25
24      WRITE(9,2003)
2003      FORMAT('Modified Hessian is singular.'//)
      EACHIT=0
        IRET=1
      GOTO 22
25      WNORM=0.0
      IF(MMM.EQ.0) GOTO 53
      DO 51 I=1,MMM
51        DK1(I)=DK(I)+W(MMX+I)
53      CONTINUE
      IF(NPC.EQ.0) GOTO 54
      DO 52 I=1,NPC
52        DX1(I)=DX(I)+W(MX+I)
54      CONTINUE
      IF(NREDE.EQ.0) GOTO 30
      MM1=MM+1
      DO29 I=MM1,NRDSTD
29      W(I)=FACTST*W(I)
30      CONTINUE
      DO 10 I=1,NPARAM
10      WNORM=WNORM+DABS(W(I))
        IF (WNORM.GT.PARS) GOTO 11
        DO 12 I=1,NPARAM
12        X1(I)=X(I)+W(I)
        DO 14 I=1,MM
14          LK(I)=X1(I)
      IF(NREDE.EQ.0) GOTO 15
        DO 16 I=1,NREDE
          I1=(I-1)*NSTODE+MM
          DO 17 J=1,NSTODE
17            P(I,J)=X1(I1+J)
16          CONTINUE
15        CONTINUE
      DO 41 I=1,NCOMP
        NVARI=NVAR(I)
      IF(NVARI.EQ.0) GOTO 41
        NVARSI=NVARS(I)
        DO 42 K=1,NVARI
42          QCOMP(I,K)=X1(NVARSI+K)
41      CONTINUE
        IF (NVRTXC.EQ.0) GOTO 43
        DO 44 I=1,NVRTXC
44        WW(NWC(I))=1.0/X1(MXC+I)
43      CONTINUE
      IF (NADJC.EQ.0) GOTO 45
      DO 46 I=1,NADJC
46        VCOMP(WADJ(I))=X1(MXW+I)
45      CONTINUE
      DO 47 I=1,NEXP
        IF(CORVM(I)) GOTO 48
        VM(I)=X1(NVM(I))
48        CONTINUE
        IF(CORALF(I)) GOTO 49
        ALFA(I)=X1(NALF(I)  )
49        CONTINUE
        IF(COREST(I)) GOTO 47
        EST(I)=X1(NEST(I))
47      CONTINUE
        IF (NWAVAR.EQ.0)GOTO 18
        DO 19 I=1,NWAVAR
          NVAI=NVA(I)
          MXNVSI=MXX+NVAS(I)
          DO 20 J=1,NVAI
20          BE(I,NVARAB(I,J))=DEXP(X1(MXNVSI+J))
19      CONTINUE
18      CONTINUE
        CALL CHARS
        CALL BLANCE
        CALL UMDES(*22)
        CALL MINSUM(UZGN)
        IF (UZGN.LE.UZG)GOTO 21
11      RLAMBD=RLAMBD*VMARQ
9       CONTINUE
        WRITE (9,2001) NUMIT
2001    FORMAT('Marquardt procedure failed in iteration',i5,'.'//)
      IF (EACHIT.EQ.0) WRITE (9,1112) NUMIT
      IF (EACHIT.EQ.0) CALL PIS(1,1,1,1,NPARAM,6,X1)
      IF (EACHIT.GT.0) CALL WRITIN
      IF (EACHIT.GT.1) CALL RESWR
      IF (EACHIT.GT.2) CALL CONCWR
      GOTO 27
21      CONTINUE
        UZG=UZGN
      IF (EACHIT.EQ.0) WRITE (9,1112) NUMIT
      IF (EACHIT.EQ.0) CALL PIS(1,1,1,1,NPARAM,6,X1)
      IF (EACHIT.GT.0) CALL WRITIN
      IF (EACHIT.GT.1) CALL RESWR
      IF (EACHIT.GT.2) CALL CONCWR
      IF (WNORM.LE.RKRYT.AND.RLAMBD.LE.1.0) GOTO 27
        DO 23 I=1,NPARAM
23          X(I)=X1(I)
      IF(MMM.EQ.0) GOTO 57
      DO 55 I=1,MMM
55        DK(I)=DK1(I)
57      CONTINUE
      IF(NPC.EQ.0) GOTO 58
      DO 56 I=1,NPC
56        DX(I)=DX1(I)
58      CONTINUE
      IF (WNORM.LE.1.0D-6) GOTO 27
        DDUMDT=0.05*WNORM/NPARAM
        IF(DDUMDT.LT.DUMDT) DUMDT=DDUMDT
        IF(DUMDT.LT.RMIND) DUMDT=RMIND
        RLAMBD=RLAMBD/VMARQ
8      CONTINUE
      WRITE(9,2002) MAXIT
2002    FORMAT('Problem not convergent in',i5,'  iterations'/)
27      SING=.FALSE.
      WRITE (9,1010) (I,W(I),I=1,NPARAM)
 1010 FORMAT (//1X,'Last increments in parameters:'/50(/I4,3X,1PD14.6))
      RLA=RLAMBD
      RLAMBD=0.0
      CALL HEVL(*22)
      GOTO 28
22      SING=.TRUE.
        IRET=1
28      CONTINUE
      WRITE (9,1000) (I,W(I),I=1,NPARAM)
1000      FORMAT (//'Final gradients:'/50(/I4,3X,1PD14.6))
      RLAMBD=RLA

      IF (EACHIT.LE.1) CALL RESWR
      IF (.NOT.SING) THEN
        CALL STATIS
      ELSE
          CALL WRITIN
        ENDIF
      IF (EACHIT.LE.2) CALL CONCWR
      IF (NPOT.EQ.0 .OR. IDERIV.EQ.0) GOTO 40
      WRITE(9,2004)
2004      FORMAT(//'Derivatives of EMF in volume:')
      CALL PIS(200,1,NPOT,1,1,6,EMFV)
      WRITE(9,2005)
2005      FORMAT(//'Derivatives of EMF in parameters:')
      CALL PIS (200,1,NPOT,1,MXX,6,EMFX)
      RETURN
40      IRET=-1
        RETURN
      END
